﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MazeSolver
{

    class Program
    {
        static void Main(string[] args)
        {
            //█████████
            //█S  █   █
            //███ █ █ █
            //█       █
            //█ █████ █
            //█      E█
            //█████████
            char[,] maze = new char[,]
            {
                {'█','█','█','█','█','█','█','█','█'},
                {'█',' ',' ',' ','█',' ',' ',' ','█'},
                {'█','█','█',' ','█',' ','█',' ','█'},
                {'█',' ',' ',' ',' ',' ',' ',' ','█'},
                {'█',' ','█','█','█','█','█',' ','█'},
                {'█',' ',' ',' ',' ',' ',' ',' ','█'},
                {'█','█','█','█','█','█','█','█','█'}
            };

            MazeStep(maze, 1, 1, 5, 7);

            Console.ReadLine();
        }

        static void MazeStep(char[,] maze, int currentX, int currentY, int endX, int endY)
        {
            if (currentX < 0 || currentX >= maze.GetLength(0) || currentY < 0 || currentY >= maze.GetLength(1))
            {
                // Out of bounds
                return;
            }

            if (maze[currentX, currentY] != ' ')
            {
                // Hit a wall or previous step
                return;
            }

            if (currentX == endX && currentY == endY)
            {
                // Found solution
                for (int i = 0; i < maze.GetLength(0); i++)
                {
                    for (int j = 0; j < maze.GetLength(1); j++)
                    {
                        Console.Write(maze[i, j]);
                    }
                    Console.WriteLine();
                }
            }

            maze[currentX, currentY] = '*';

            if (currentX - 1 >= 0)
            {
                MazeStep(maze, currentX - 1, currentY, endX, endY);
            }

            if (currentX + 1 < maze.GetLength(0))
            {
                MazeStep(maze, currentX + 1, currentY, endX, endY);
            }

            if (currentY - 1 >= 0)
            {
                MazeStep(maze, currentX, currentY - 1, endX, endY);
            }

            if (currentY + 1 < maze.GetLength(1))
            {
                MazeStep(maze, currentX, currentY + 1, endX, endY);
            }

            maze[currentX, currentY] = ' ';
        }

    }
}
